#include <cmath>
#include <iostream>
#include "complexe.hpp"
#include "polynome_2.hpp"

using namespace std;

int main (){
  polynome P(1);
  complexe x0(1.5,0.1);
  complexe x(1,0),y(2,0);
  
  P.set(x,0);
  P.set(y,1);
  cout<<"Polynome P: "<<P<<" x "<<x<<" "<<y<<endl;

  polynome P2(P);
  P.adresse();
  P2.adresse();

  cout<<" adresse "<<&P<<" adresse P2"<<&P2<<endl;

  polynome Q;
  Q=P.derivative();
  cout<<"Polynome Q: "<<Q<<endl;

  polynome R;
  R = Q+P;
  cout<<"Polynome R=P+Q: "<<R<<endl;

  R = Q*P;
  cout<<"Polynome R=Q*P: "<<R<<endl;

  polynome R2;
  R2= P*R;
  cout<<"Polynome R2=P*R: "<<R2<<endl;

  polynome R3;
  R3= R2*R;
  cout<<"Polynome R3=R2*R: "<<R3<<endl;
  
  polynome S;
  S= R.primitive();
  cout<<S<<endl;
  cout<<S(complexe(1.0,0.0))<<endl;

  cout<<"coeff 0:"<<P[0]<<endl;
  cout<<"eval P(x0):"<<P(x0)<<endl;
  cout<<"Produit scalaire: "<<(P,Q)<<endl;

  //  polynome T(1);
  //cin >> T;
  //cout<<T<<endl;

  cout<<"coucou "<<endl;
  polynome * Ptab;
  Ptab = new polynome[3];
  Ptab[0] = P;
  Ptab[1] = Q;
  Ptab[2] = R;
  cout<<"Polynome 0: "<<Ptab[0]<<endl;
  cout<<"Polynome 1: "<<Ptab[1]<<endl;
  cout<<"Polynome 2: "<<Ptab[2]<<endl;
  cout<<"Polynome 0, coef 0: "<<Ptab[0][0]<<endl;
  cout<<"Polynome 0, coef 1: "<<Ptab[0][1]<<endl;
  cout<<" norm de P_0 :"<<Ptab[0].norm2()<<endl;

  return 0;
};

